ompi/tools/wrappers/ompi_wrap.h File Reference.TH "ompi/tools/wrappers/ompi_wrap.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
ompi/tools/wrappers/ompi_wrap.h \- All of these types, global variables, and functions are internal to the ompi_info program. 
.SH SYNOPSIS
.br
.PP
\fC#include 'ompi_config.h'\fP
.br
\fC#include <string>\fP
.br
\fC#include <vector>\fP
.br

.SS "Defines"

.in +1c
.ti -1c
.RI "#define \fBOMPI_WRAP_H\fP   1"
.br
.in -1c
.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef std::vector< std::string > \fBompi_sv_t\fP"
.br
.RI "\fICommonly used type. \fP"
.in -1c
.SS "Functions"

.in +1c
.ti -1c
.RI "int \fBompi_wrap_engine\fP (int argc, char *argv[], const \fBompi_sv_t\fP &compiler_env_var, const \fBompi_sv_t\fP &xppflags_env_var, const \fBompi_sv_t\fP &xflags_env_var, const \fBompi_sv_t\fP &ldflags_env_var, const \fBompi_sv_t\fP &libs_env_var, const std::string &default_compiler, const std::string &default_xflags, bool want_cxx_libs, bool want_f90_libs, bool want_f77_includes)"
.br
.RI "\fIFunctions in the helper OMPI wrapper compiler library; this is the granddaddy that will invoke the rest. \fP"
.ti -1c
.RI "void \fBompi_wrap_parse_args\fP (int argc, char *argv[], bool &want_flags)"
.br
.RI "\fIParse the command line arguments of the wrapper compiler. \fP"
.ti -1c
.RI "void \fBompi_wrap_get_compiler\fP (const \fBompi_sv_t\fP &env_list, const std::string &default_comp, \fBompi_sv_t\fP &out)"
.br
.RI "\fIFigure out what the back-end compiler is (even if it's multiple tokens). \fP"
.ti -1c
.RI "void \fBompi_wrap_build_xppflags\fP (const \fBompi_sv_t\fP &env_list, bool want_f77_includes, \fBompi_sv_t\fP &xppflags)"
.br
.RI "\fIBuild up a list of arguments for XPPFLAGS (CPPFLAGS, CXXCPPFLAGS or FPPFFLAGS, depending on what the front-end wrapper compiler is). \fP"
.ti -1c
.RI "void \fBompi_wrap_build_xflags\fP (const \fBompi_sv_t\fP &env_list, const std::string &default_xflags, \fBompi_sv_t\fP &xflags)"
.br
.RI "\fIBuild of a list of XFLAGS (CFLAGS, CXXFLAGS, FFLAGS, FCFLAGS) to go to the back-end compiler. \fP"
.ti -1c
.RI "void \fBompi_wrap_build_user_args\fP (int argc, char *argv[], \fBompi_sv_t\fP &user_args)"
.br
.RI "\fIBuild up a list of user arguments (from argc/argv) that will be plugged into the command line that will invoke the back-end compiler. \fP"
.ti -1c
.RI "void \fBompi_wrap_build_ldflags\fP (const \fBompi_sv_t\fP &env_list, \fBompi_sv_t\fP &ldflags)"
.br
.RI "\fIBuild up a list of LDFLAGS that will be given to the back-end compiler. \fP"
.ti -1c
.RI "void \fBompi_wrap_build_libs\fP (const \fBompi_sv_t\fP &env_list, bool want_cxx_libs, bool want_f90_libs, \fBompi_sv_t\fP &libs)"
.br
.RI "\fIBuild up a list of LIBS that will be given to the back-end compiler. \fP"
.ti -1c
.RI "void \fBompi_wrap_print_sv\fP (const \fBompi_sv_t\fP &sv)"
.br
.RI "\fIPrint out a vector of strings. \fP"
.ti -1c
.RI "int \fBompi_wrap_exec_sv\fP (const \fBompi_sv_t\fP &sv)"
.br
.RI "\fIExecute a vector of strings (ultimately results down to a call to some flavor of exec()). \fP"
.ti -1c
.RI "void \fBompi_wrap_strip_white\fP (std::string &str)"
.br
.RI "\fIRemove leading and trailing white space from a given string. \fP"
.ti -1c
.RI "bool \fBompi_wrap_split\fP (const std::string &str, char c, \fBompi_sv_t\fP &out)"
.br
.ti -1c
.RI "void \fBompi_wrap_split_append_sv\fP (const std::string &str, \fBompi_sv_t\fP &out)"
.br
.RI "\fITake a string, split it into tokens, and append it to an existing vector of strings. \fP"
.ti -1c
.RI "void \fBompi_wrap_append_sv\fP (const \fBompi_sv_t\fP &in, \fBompi_sv_t\fP &out)"
.br
.RI "\fIAppend one vector of strings onto the end of another. \fP"
.ti -1c
.RI "bool \fBompi_wrap_check_file\fP (const std::string &dir, const std::string &file)"
.br
.RI "\fICheck for the presence of a file. \fP"
.in -1c
.SS "Variables"

.in +1c
.ti -1c
.RI "bool \fBshowme_cmd\fP"
.br
.RI "\fIWhether we're showing the entire command or not. \fP"
.ti -1c
.RI "bool \fBshowme_compile\fP"
.br
.RI "\fIWhether we're showing the compile command or not. \fP"
.ti -1c
.RI "bool \fBshowme_link\fP"
.br
.RI "\fIWhether we're showing the link command or not. \fP"
.in -1c
.SH "Detailed Description"
.PP 
All of these types, global variables, and functions are internal to the ompi_info program. 

There is probably noting here of value outside of ompi_info.
.SH "Function Documentation"
.PP 
.SS "void ompi_wrap_append_sv (const \fBompi_sv_t\fP & in, \fBompi_sv_t\fP & out)"
.PP
Append one vector of strings onto the end of another. 
.PP
\fBParameters:\fP
.RS 4
\fIin\fP Vector of strings to be appended 
.br
\fIout\fP Vector of strings to which 'in' will be appended 
.RE
.PP

.SS "void ompi_wrap_build_ldflags (const \fBompi_sv_t\fP & env_list, \fBompi_sv_t\fP & ldflags)"
.PP
Build up a list of LDFLAGS that will be given to the back-end compiler. 
.PP
\fBParameters:\fP
.RS 4
\fIldflags\fP Vector of strings comtaining the LDFLAGS 
.RE
.PP

.SS "void ompi_wrap_build_libs (const \fBompi_sv_t\fP & env_list, bool want_cxx_libs, bool want_f90_libs, \fBompi_sv_t\fP & libs)"
.PP
Build up a list of LIBS that will be given to the back-end compiler. 
.PP
\fBParameters:\fP
.RS 4
\fIwant_cxx_libs\fP Are we building mpiCC? 
.br
\fIlibs\fP Vector of strings containing the libraries to be linked to the backend compiler 
.RE
.PP

.SS "void ompi_wrap_build_user_args (int argc, char * argv[], \fBompi_sv_t\fP & user_args)"
.PP
Build up a list of user arguments (from argc/argv) that will be plugged into the command line that will invoke the back-end compiler. 
.PP
\fBParameters:\fP
.RS 4
\fIargc\fP Number of command line parameters 
.br
\fIargv\fP Vector containing the command line parameters 
.br
\fIuser_args\fP List of user arguments that will be passed to the back-end compiler (return value) 
.RE
.PP

.SS "void ompi_wrap_build_xflags (const \fBompi_sv_t\fP & env_list, const std::string & default_xflags, \fBompi_sv_t\fP & xflags)"
.PP
Build of a list of XFLAGS (CFLAGS, CXXFLAGS, FFLAGS, FCFLAGS) to go to the back-end compiler. 
.PP
These are typically extra flags that come from the configure script.
.PP
\fBParameters:\fP
.RS 4
\fIextra_string\fP Extra flags to be passed to backend compiler 
.br
\fIextra_flags\fP Vector of strings to be pased to backend compiler (return value) 
.RE
.PP

.SS "void ompi_wrap_build_xppflags (const \fBompi_sv_t\fP & env_list, bool want_f77_includes, \fBompi_sv_t\fP & xppflags)"
.PP
Build up a list of arguments for XPPFLAGS (CPPFLAGS, CXXCPPFLAGS or FPPFFLAGS, depending on what the front-end wrapper compiler is). 
.PP
\fBParameters:\fP
.RS 4
\fIwant_f77_includes\fP If F77 includes are wanted 
.br
\fIcflags\fP Vector of strings containing the cflags (returned) 
.RE
.PP

.SS "bool ompi_wrap_check_file (const std::string & dir, const std::string & file)"
.PP
Check for the presence of a file. 
.PP
\fBParameters:\fP
.RS 4
\fIdir\fP Directory in which the file should be present 
.br
\fIfile\fP Name of the file 
.RE
.PP

.SS "int ompi_wrap_engine (int argc, char * argv[], const \fBompi_sv_t\fP & compiler_env_var, const \fBompi_sv_t\fP & xppflags_env_var, const \fBompi_sv_t\fP & xflags_env_var, const \fBompi_sv_t\fP & ldflags_env_var, const \fBompi_sv_t\fP & libs_env_var, const std::string & default_compiler, const std::string & default_xflags, bool want_cxx_libs, bool want_f90_libs, bool want_f77_includes)"
.PP
Functions in the helper OMPI wrapper compiler library; this is the granddaddy that will invoke the rest. 
.PP
All three wrapper compilers invoke this function.
.PP
\fBParameters:\fP
.RS 4
\fIargc\fP Number of command line arguments 
.br
\fIargv\fP Vector containing command line arguments 
.br
\fIenv_vars\fP Environment variables 
.br
\fIdefault_compiler\fP The default backend compiler 
.br
\fIwant_cxx_libs\fP Whether C++ libraries should be linked in 
.br
\fIwant_f77_includes\fP Whether F77 include path should be added 
.br
\fIextra_args\fP Extra arguments which need to be added
.RE
.PP
At most, we end up with a command line in the following form:
.PP
[compiler(*)] [Xppflags(*)] [Xflags(*)] [user args] [ldflags(*)] [libs(*)]
.PP
Items with (*) can be overridden at run time with environment variables.
.PP
X can be replaced with C, CXX, F, and FC for C, C++, Fortran 77, and Fortran 90, respectively. 
.SS "int ompi_wrap_exec_sv (const \fBompi_sv_t\fP & sv)"
.PP
Execute a vector of strings (ultimately results down to a call to some flavor of exec()). 
.PP
\fBParameters:\fP
.RS 4
\fIsv\fP Vector of strings to be exec()'ed 
.RE
.PP

.SS "void ompi_wrap_get_compiler (const \fBompi_sv_t\fP & env_list, const std::string & default_comp, \fBompi_sv_t\fP & out)"
.PP
Figure out what the back-end compiler is (even if it's multiple tokens). 
.PP
\fBParameters:\fP
.RS 4
\fIenv_list\fP List of environment variables passed by the user 
.br
\fIdefault_comp\fP Defaultl backend compiler 
.br
\fIout\fP Compiler to use (return value) 
.RE
.PP

.SS "void ompi_wrap_parse_args (int argc, char * argv[], bool & want_flags)"
.PP
Parse the command line arguments of the wrapper compiler. 
.PP
\fBParameters:\fP
.RS 4
\fIargc\fP Number of command line parameters 
.br
\fIargv\fP Vector containing command line parameters 
.br
\fIwant_flags\fP True if extra flags are needed 
.RE
.PP

.SS "void ompi_wrap_print_sv (const \fBompi_sv_t\fP & sv)"
.PP
Print out a vector of strings. 
.PP
\fBParameters:\fP
.RS 4
\fIsv\fP Vector of strings to be printed out 
.RE
.PP

.SS "bool ompi_wrap_split (const std::string & str, char c, \fBompi_sv_t\fP & out)"
.PP
\fBParameters:\fP
.RS 4
\fIstr\fP String which has to be split into a vector of strings 
.br
\fIc\fP Charecter which demarkates 2 strings 
.br
\fIout\fP Vector of strings (return value) 
.RE
.PP

.SS "void ompi_wrap_split_append_sv (const std::string & str, \fBompi_sv_t\fP & out)"
.PP
Take a string, split it into tokens, and append it to an existing vector of strings. 
.PP
\fBParameters:\fP
.RS 4
\fIstr\fP String which is to be split into tokens 
.br
\fIout\fP Vector of strings to which the tokens are appended 
.RE
.PP

.SS "void ompi_wrap_strip_white (std::string & str)"
.PP
Remove leading and trailing white space from a given string. 
.PP
Must be sent a null-terminated string.
.PP
\fBParameters:\fP
.RS 4
\fIstr\fP String from which leading and trailing spaces should be removed 
.RE
.PP

.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
